package com.javacodegeeks.examples;

import static org.junit.Assert.*;

import java.io.IOException;
import java.net.URISyntaxException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.stream.Collectors;
import java.util.stream.Stream;

import org.junit.Before;
import org.junit.Test;

public class StringIndentTest {
	
	String data_from_file;
	
	private String buildHTMLWithIndent() {
		StringBuilder html_string = new StringBuilder();
		html_string.append("    <html>\n");
		html_string.append("        <body>\n");
		html_string.append("            <p>Hello Code Geeks!</p>\n");
		html_string.append("        </body>\n");
		html_string.append("    </html>\n");
		return html_string.toString();
	}
	
	private String buildHTMLWithoutIndent() {
		StringBuilder html_string = new StringBuilder();
		html_string.append("<html>\n");
		html_string.append("<body>\n");
		html_string.append("<p>Hello Code Geeks!</p>\n");
		html_string.append("</body>\n");
		html_string.append("</html>\n");
		return html_string.toString();
	}
	
	@Before
	public void loadHTMLFile() throws URISyntaxException, IOException {
		Path path = Paths.get(getClass().getClassLoader().getResource("helloworld.html").toURI());
		Stream<String> lines = Files.lines(path);
		data_from_file = lines.collect(Collectors.joining("\r"));
		lines.close();
	}
	
	@Test
	public void test_remove_spaces() {
		System.out.println(data_from_file.indent(-12));
		assertTrue("strings do not match", data_from_file.indent(-12).equals(buildHTMLWithoutIndent()));
	}
	
	@Test
	public void test_add_spaces() throws URISyntaxException, IOException {
		System.out.println(data_from_file.indent(4));
		assertTrue("strings do not match", data_from_file.indent(4).equals(buildHTMLWithIndent()));
	}

}
