package com.javacodegeeks.examples;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertThat;
import static org.junit.Assert.assertTrue;

import java.util.List;
import java.util.Optional;
import java.util.stream.Stream;

import org.junit.Test;

public class StringTransformTest {
	
	static Stream<String> sortList(String list) {
		return List.of(list.split(",")).stream().sorted();
	}


	@Test
	public void testTransfromPhrase() {
		String phrase = "this is a sentence";
		String sentence = phrase.transform(s -> s.substring(0, 1).toUpperCase() + s.substring(1) + ".");
		assertTrue("phrase was not transformed", sentence.equalsIgnoreCase("This is a sentence."));
	}

	@Test
	public void testTransfromToStream() {
		String fruits = "Kiwi,Banana,Apple";
		Stream<String> transformed = fruits.transform(StringTransformTest::sortList);
		Optional<String> result = transformed.findFirst();
		assertThat(result.get(), is("Apple"));
	}

}
